---
geometry:
- top=15mm
- bottom=15mm
- margin=10mm
---
Contributor Agreement
=====================

Thank you for your interest in contributing to Frama-C, distributed by
the Commissariat à l'Energie Atomique et aux Energies Alternatives
(\"We\" or \"Us\").

The purpose of this Contributor Non-Exclusive License Agreement
(\"Agreement\") is to clarify and document the rights granted by
contributors to Us. To make this document effective and get started,
please sign the Contributor License Agreement.

Please read this document carefully before signing and keep a copy for
your records.

**1. DEFINITIONS**

**\"You\" (/"Your")** means the Individual Copyright owner or Entity as
defined hereunder who submits a Contribution to Us. If You are an
employee and submit the Contribution as part of your employment, You
represent that you have the authority and/or required authorization in
binding the Entity to this Agreement, and to sign this version of this
document. In such case "You" (/"Yours") shall refer to such Entity.

**\"Documentation\"** means any non-software portion of a Contribution.

**"Entity"** shall mean the copyright owner or legal entity (including
but not limited to any institution, company, corporation, partnership,
government agency or university) authorized by the copyright owner that
is making this Agreement with Us and all other entities that control,
are controlled by, or are under common control with that entity are
considered to be a single Contributor. For the purposes of this
definition, \"control\" means (i) the power, direct or indirect, to
cause the direction or management of such entity, whether by contract or
otherwise, or (ii) ownership of fifty percent (50%) or more of the
outstanding shares, or (iii) beneficial ownership of such entity.

**\"Contribution\"** means any original work of authorship (software
and/or documentation) including any modifications or additions to an
existing work, Submitted by You to Us, in which You own the Copyright.

**\"Copyright\"** means all rights protecting works of authorship owned
or controlled by You, including copyright, moral and neighboring rights,
as appropriate, for the full term of their existence including any
extensions by You.

**\"Submit\"** means any form of physical, electronic, or written
communication sent to Us, including but not limited to electronic
mailing, source code control systems, and issue tracking systems that
are managed by, or on behalf of, Us, but excluding communication that is
clearly designated in writing by You as \"Not a Contribution.\"

\"**Work**\" means any software or documentation made available by Us to
third parties. Any Contribution You Submit may be included in the
Material.

**2. GRANT OF LICENSE**

> **2.1 Grant of Copyright License.**

Subject to the terms and conditions of this Agreement, You hereby grant
to Us a worldwide, royalty-free, no-charge, non-exclusive, perpetual and
irrevocable Copyright license, with the right to transfer an unlimited
number of non-exclusive licenses or to grant non-exclusive sublicenses
to third parties, to use the Contribution by all means, including but
not limited to, the right to :

-   Publish the Contribution in original or modified form ;

-   Modify the Contribution, prepare derivative works based upon or
    containing the Contribution and combine the Contribution with other
    works;

-   Reproduce the Contribution in original or modified form;

-   Distribute, make the Contribution available to the public, display
    and publicly perform the Contribution in original or modified form
    under the terms of any license approved by Us.

> **2.2 Moral Rights**

Moral Rights remain unaffected to the extent they are recognized and not
waivable by applicable law. Notwithstanding, You may add your name in
the header of the source code files of Your Contribution and We will
respect this attribution when using Your Contribution.

**3. GRANT OF PATENT LICENSE**

Subject to the terms and conditions of this Agreement, You hereby grant
to Us a perpetual, worldwide, non-exclusive, no-charge, royalty-free,
irrevocable patent license, with the right to transfer an unlimited
number of non-exclusive licenses or to grant sublicenses to third
parties, to make, have made, use, offer to sell, sell, import, and
otherwise transfer the Contribution, where such license applies only to
those patent claims licensable by You that are necessarily infringed by
Your Contribution(s) alone or by combination of Your Contribution(s)
with the Work to which such Contribution(s) was submitted.

This license applies to all patents owned or controlled by You, whether
already acquired or hereafter acquired, that would be infringed by
making, having made, using, selling, offering for sale, importing or
otherwise transferring of Your Contribution(s) alone or by combination
of Your Contribution(s) with the Material.

You furthermore agree to notify Us of any patents that you know or come
to know which are likely infringed by the Contribution and/or are not
licensable by You.

If any entity institutes patent litigation against You or any other
entity alleging that the Contribution, or the Work with which it has
been combined, constitutes direct or contributory patent infringement,
then any patent licenses granted to that entity under this Agreement for
that Contribution or Material shall terminate as of the date such
litigation is filed.

If the litigation is withdrawn or otherwise settled, then any patent
licenses granted to that entity under this agreement shall be reinstated
as of the date the litigation was settled or withdrawn.

**4. REPRESENTATIONS**

a\. If You are entering this Agreement as an individual, You represent
that You are legally entitled to grant the licenses set forth in
Sections 2 and 3. If Your employer(s) has rights to intellectual
property that You create, such as your Contributions, You represent that
You have received permission to make Contributions on behalf of that
employer and that Your employer has waived such rights for Your
Contributions to the Work.

b\. If You are entering this Agreement on behalf of an Entity, You
represent that You are legally entitled to grant the licenses set forth
in Sections 2 and 3 and that each employee of the Entity that submits
Contributions is authorized to submit such Contributions on behalf of
the Entity.

In any case, You represent that:

i\. The Contribution is Your original creation. If You do not, entirely
or partially, own the Copyright in work of authorship comprising a
Contribution, please contact Us before Submitting such Contribution.

ii\. to the extent that Your Contribution is computer code, it includes
complete details of any third-party license or other restriction
(including, but not limited to, related patents and trademarks) of which
You are personally aware and which are associated with any part of Your
Contributions.

iii\. to the extent that Your Contribution is computer code, it contains
no viruses, Trojan horses, backdoors, malicious code or other program
that would allow anyone, including Us, to gain access to a computer or
network other than what is fully documented and disclosed by Us.

**5. DISCLAIMER OF WARRANTIES**

Except as set forth in section 4, the contribution is provided \"as
is\". More particularly, all express or implied warranties including,
without limitation, any implied warranty of merchantability, fitness for
a particular purpose and non-infringement are expressly disclaimed by
You to Us and by Us to You. To the extent that any such warranties
cannot be disclaimed, such warranty is limited in duration to the
minimum period permitted by law.

**6. CONSEQUENTIAL, APPROXIMATION OF DISCLAIMER AND DAMAGE WAIVER**

To the maximum extent permitted by applicable law, in no event will You
or Us be liable for any loss of profits, loss of anticipated savings,
loss of data, indirect, special, incidental, consequential and exemplary
damages arising out of this Agreement regardless of the legal or
equitable theory (contract, tort or otherwise) upon which the claim is
based.

If the disclaimer and damage waiver mentioned in section 5 and section 6
cannot be given legal effect under applicable local law, reviewing
courts shall apply local law that most closely approximates an absolute
waiver of all civil liability in connection with the contribution.

**7. TERM**

This Agreement shall come into effect upon Your acceptance of the terms
and conditions.

In the event of a termination of this Agreement Sections 5, 6 and 8
shall survive such termination and shall remain in full force
thereafter. For the avoidance of doubt, Contributions that are already
licensed under a free and open source license at the date of the
termination shall remain in full force after the termination of this
Agreement.

**8. MISCELLANEOUS**

8.1 You are not expected to provide support for Your Contributions,
except to the extent You desire to provide support. You may provide
support for free, for a fee, or not at all. Unless required by
applicable law or agreed to in writing, You provide Your Contributions
on an \"as is\" basis, without warranties or conditions of any kind,
either express or implied, including, without limitation, any warranties
or conditions of title, non-infringement, merchantability, or fitness
for a particular purpose.

8.2 This Agreement and all disputes, claims, actions, suits or other
proceedings arising out of this agreement or relating in any way to it
shall be governed by the laws of France excluding its private
international law provisions.

8.3 This Agreement sets out the entire agreement between You and Us for
Your Contributions to Us and overrides all other agreements or
understandings.

8.4 If any provision of this Agreement is found void and unenforceable,
such provision will be replaced to the extent possible with a provision
that comes closest to the meaning of the original provision and that is
enforceable. The terms and conditions set forth in this Agreement shall
apply notwithstanding any failure of essential purpose of this Agreement
or any limited remedy to the maximum extent possible under law.

8.5 You agree to notify Us of any facts or circumstances of which you
become aware that would make this Agreement inaccurate in any respect.

**Signature**

- Full Name:
- Entity (if applicable):
- Country/Town:
- (optional) Full address:
- Email:
- Gitlab login:
- Date:
- Signature:
