**Trivial Contribution Policy**

The purpose of this Policy is to clarify and document the circumstances
in which a Contribution, deemed as Trivial, does not fall within the
scope of the Contributor License Agreement.

As a general rule, Contributions that do not involve creative decisions
or which are not substantial will be considered to be Trivial.

As a guideline, a Contribution may be qualified according to the
following:

+-----------------------+-----------------------+-----------------------+
| *Type of              | *≤ 10 lines*          | *\> 10 lines*         |
| contribution*         |                       |                       |
+=======================+=======================+=======================+
| Feature               |                       |                       |
|                       | • Not trivial         | • Not trivial         |
| (add new functional   |                       |                       |
| behavior)             |                       |                       |
+-----------------------+-----------------------+-----------------------+
| Improvement           |                       |                       |
|                       | • Probably            | • Not trivial         |
| (improve              |   not trivial         |                       |
| non-functional        |                       |                       |
| behavior)             |                       |                       |
+-----------------------+-----------------------+-----------------------+
|                       | • Not trivial if      | • Not trivial if      |
|                       | creative code         | creative code         |
| Bug fix               |                       |                       |
|                       | • Not trivial if      | • Not trivial if      |
| (fix incorrect        | comprises a creative  | comprises a creative  |
| behavior)             | comment               | comment               |
|                       |                       |                       |
|                       | • Probably trivial    | • Probably not        |
|                       | otherwise             | trivial otherwise     |
+-----------------------+-----------------------+-----------------------+

(1) -   -   -   

<!-- -->

(1) 

Without prejudice to the above, and for all intents and purposes, the
following Contributions are deemed to be Trivial:

-   Spelling / grammar fixes / correcting typos

-   Formatting / cleaning up comments in the code.

-   Contributions that are purely deletions, such as removal of
    duplicate information or code that never executes.

-   Bug fixes that change default return values or error codes stored in
    constants, literals, or simple variable types.

-   Adding logging messages or debugging output.

-   Changes to 'metadata' files.

-   Renaming a build directory or changing a constant.

-   Configuration changes.

-   Changes in build or installation scripts.

-   Re-ordering of objects or subroutines.

-   Moving source files from one directory or package to another, with
    no changes in code.

-   Breaking a source file into multiple source files, or consolidating
    multiple source files into one source file, with no code changes.

However, there are many gray areas. Please reach us at `cla AT frama-c DOT com`
should you have any questions on the nature of your
intended Contribution.
